Attribute VB_Name = "MODULE2"
Option Explicit

Public Sub CalculateTransitData()
    Dim x1b%

    Call FetchDiurnalData

'do transit calculations
    iday% = DiurnalDay%
    imonth% = DiurnalMonth%
    iyear% = DiurnalYear%

    ihour! = Val(Finding_Lucky_Times!txtDiurnalHour.Text)
    If Finding_Lucky_Times!optDiurnalAM.Value = True Then
        If Fix(ihour!) = 12 Then
            ihour! = ihour! - 12
        End If
    Else
        If Fix(ihour!) <> 12 Then
            ihour! = ihour! + 12
        End If
    End If

    ihour! = ihour! + DiurnalTimeZone!
    imin! = Val(Finding_Lucky_Times!txtDiurnalMinute.Text)

    lon = Val(Finding_Lucky_Times!txtDiurnalLongDeg.Text) + (Val(Finding_Lucky_Times!txtDiurnalLongMin.Text) / 60)
    lat = Val(Finding_Lucky_Times!txtDiurnalLatDeg.Text) + (Val(Finding_Lucky_Times!txtDiurnalLatMin.Text) / 60)

    If UCase$(DiurnalD1$) = "WEST" Then lon = -lon
    If UCase$(DiurnalD2$) = "SOUTH" Then lat = -lat

    lon_transit = lon
    lat_transit = lat

    Call Get_all_planet_positions(1)

    For x1b% = 1 To NumberOfPlanets%
        Transit(x1b%) = Planets(x1b%)
        TransitSpeed(x1b%) = Speed(x1b%)
    Next x1b%

    TransitH$ = Retrograde$
End Sub


Public Sub Calculate_Natal_and_Transit_Positions()
    LineCounter& = 0: TextLineCounter& = 0
    ReDim OutputLines$(0 To 1), TextOnForm$(0 To 1)

    InputErrorFlag% = 0

    Call CheckInputErrors
    Call CheckOverflowErrorsNatal
    Call CheckOverflowErrorsDiurnal

    If InputErrorFlag% = 1 Then Exit Sub

    Screen.MousePointer = 11

'do natal calculations
    Call CalculateNatalData

'do transit calculations
    Call CalculateTransitData

    Screen.MousePointer = 0
End Sub

Public Sub CalculateNatalData()
    Dim x1b%

    Call FetchNatalData

    iday% = NatalDay%
    imonth% = NatalMonth%
    iyear% = NatalYear%

    ihour! = Val(Finding_Lucky_Times!txtBirthHour.Text)
    If Finding_Lucky_Times!optAM.Value = True Then
        If Fix(ihour!) = 12 Then
            ihour! = ihour! - 12
        End If
    Else
        If Fix(ihour!) <> 12 Then
            ihour! = ihour! + 12
        End If
    End If

    ihour! = ihour! + NatalTimeZone!
    imin! = Val(Finding_Lucky_Times!txtBirthMinute.Text)

    lon = Val(Finding_Lucky_Times!txtLongDeg.Text) + (Val(Finding_Lucky_Times!txtLongMin.Text) / 60)
    lat = Val(Finding_Lucky_Times!txtLatDeg.Text) + (Val(Finding_Lucky_Times!txtLatMin.Text) / 60)

    If UCase$(NatalD1$) = "WEST" Then lon = -lon
    If UCase$(NatalD2$) = "SOUTH" Then lat = -lat

    lon_natal = lon
    lat_natal = lat

    Call Get_all_planet_positions(0)                            'does house cusps, too

    For x1b% = 1 To NumberOfPlanets%
        Natal(x1b%) = Planets(x1b%)
        NatalSpeed(x1b%) = Speed(x1b%)
    Next x1b%

    NatalH$ = Retrograde$


    ReDim Natal_Decl(NumberOfPlanets%)
    
    Call Get_all_planet_positions_DECL                            'does house cusps, too
End Sub

Public Sub Get_all_planet_positions(n_t%)
    Dim cal As Byte, ret_flag As Long, y%
    Dim x(6) As Double, cusp(13) As Double, ascmc(10) As Double
    Dim iflag As Long, plnam$, retval As Long, serr$, tjd_et As Double

' the next two functions do the same job, converting a calendar date into a Julian day number
' swe_date_conversion() checks for legal dates while swe_julday() handles
' even illegal things like 45 Januar etc.
    cal = 103       'g for Gregorian calendar

    h = ihour! + imin! / 60#
    tjd_ut = swe_julday(iyear%, imonth%, iday%, h, 1)
    retval = swe_date_conversion(iyear, imonth, iday, h, cal, tjd_ut)

    If n_t% = 0 Then
        NatalJD = tjd_ut
    Else
        DiurnalJD = tjd_ut
    End If

    tjd_et = tjd_ut + swe_deltat(tjd_ut)

    If Finding_Lucky_Times!optZodiac(1).Value = True Then
        ret_flag = swe_set_sid_mode(SE_SIDM_FAGAN_BRADLEY, 0, 0)
        iflag = SEFLG_SPEED + SEFLG_SWIEPH + SEFLG_SIDEREAL          '258 - for geo tropical
    Else
        iflag = SEFLG_SPEED + SEFLG_SWIEPH          '258 - for geo tropical
    End If

    'get individual geo planets
    For y% = 1 To NumberOfPlanets%
        If pl_type$(y%) = "g" Or pl_type$(y%) = "t" Or pl_type$(y%) = "d" Or pl_type$(y%) = "a" Then
            serr$ = String(255, 0)
            plnam$ = String(20, 0)

            ret_flag = swe_calc(tjd_et, pl_ephem_number(y%), iflag, x(0), serr$)
            
            Planets(y%) = x(0)
            Speed(y%) = x(3)
            
            If y% = xSE_S_NODE Then Planets(y%) = CRUNCH(Planets(y%) + 180)
        End If
    Next y%

    'get house cusps and some other personal points
    If Finding_Lucky_Times!optHouseSystem(0).Value = True Then
        ret_flag = swe_houses_ex(tjd_ut, iflag, lat, lon, Asc("p"), cusp(0), ascmc(0))         'Placidus
    ElseIf Finding_Lucky_Times!optHouseSystem(1).Value = True Then
        ret_flag = swe_houses_ex(tjd_ut, iflag, lat, lon, Asc("k"), cusp(0), ascmc(0))         'Koch
    ElseIf Finding_Lucky_Times!optHouseSystem(2).Value = True Then
        ret_flag = swe_houses_ex(tjd_ut, iflag, lat, lon, Asc("e"), cusp(0), ascmc(0))         'equal houses from the Asc
    ElseIf Finding_Lucky_Times!optHouseSystem(3).Value = True Then
        ret_flag = swe_houses_ex(tjd_ut, iflag, lat, lon, Asc("e"), cusp(0), ascmc(0))         'equal houses from the Asc
    End If

    true_ascendant = ascmc(0)
    
    For y% = 1 To NumberOfPlanets%
        'I have to make my own whole sign cusps with 0-0 on the cusp
        If pl_type$(y%) = "c" Then
            If Finding_Lucky_Times!optHouseSystem(2).Value = True Then
                Planets(y%) = Fix(cusp(Val(pl_name$(y%))) / 30) * 30
                Speed(y%) = 0           'house cusps are never Rx
            Else
                Planets(y%) = cusp(Val(pl_name$(y%)))
                Speed(y%) = 0           'house cusps are never Rx
            End If
        End If
    Next y%


    'now calculate the various "points"
    For y% = 1 To NumberOfPlanets%
        If pl_type$(y%) = "p" Or pl_type$(y%) = "l" Then
            If pl_name$(y%) = "ASC" Then
                Planets(y%) = ascmc(0)
                Speed(y%) = 0
            End If
            
            If pl_name$(y%) = "MC" Then
                Planets(y%) = ascmc(1)
                Speed(y%) = 0
            End If
            
            If pl_name$(y%) = "EQU_ASC" Then
                Planets(y%) = ascmc(4)
                Speed(y%) = 0
            End If
            
            If pl_name$(y%) = "CO_ASC_WK" Then
                Planets(y%) = ascmc(5)
                Speed(y%) = 0
            End If

            If pl_name$(y%) = "CO_ASC_MM" Then
                Planets(y%) = ascmc(6)
                Speed(y%) = 0
            End If

            If pl_name$(y%) = "POLAR_ASC" Then
                Planets(y%) = ascmc(7)
                Speed(y%) = 0
            End If

            If pl_name$(y%) = "VERTEX" Then
                Planets(y%) = ascmc(3)
                Speed(y%) = 0
            End If
            
            If pl_name$(y%) = "POF_d" Then
                Planets(y%) = CRUNCH(ascmc(0) + Planets(xSE_MOON) - Planets(xSE_SUN))
                Speed(y%) = 0
            End If
            
            If pl_name$(y%) = "POF_n" Then
                Planets(y%) = CRUNCH(ascmc(0) - Planets(xSE_MOON) + Planets(xSE_SUN))
                Speed(y%) = 0
            End If
        
            If pl_name$(y%) = "ARIES_PT" Then
                Planets(y%) = 0
                Speed(y%) = 0
            End If
        
            If pl_name$(y%) = "AP_1" Then
                Planets(y%) = CRUNCH(ascmc(0) + cusp(5) - Planets(xSE_CHIRON))
                Speed(y%) = 0
            End If
        
            If pl_name$(y%) = "AP_2" Then
                Planets(y%) = CRUNCH(ascmc(0) + Planets(xSE_N_NODE) - Planets(xSE_TRANS_PLUTO))
                Speed(y%) = 0
            End If
        
            If pl_name$(y%) = "AP_3" Then
                Planets(y%) = CRUNCH(ascmc(0) + Planets(xSE_JUPITER) - Planets(xSE_URANUS))
                Speed(y%) = 0
            End If
        
            If pl_name$(y%) = "AP_4" Then
                Planets(y%) = CRUNCH(ascmc(0) + Planets(xSE_CHIRON) - Planets(xSE_POF_d))
                Speed(y%) = 0
            End If
        
            If pl_name$(y%) = "AP_5" Then
                Planets(y%) = CRUNCH(ascmc(0) + Planets(xSE_CHIRON) - Planets(xSE_POF_n))
                Speed(y%) = 0
            End If
        
            If pl_name$(y%) = "AP_6" Then
                Planets(y%) = 0
                Speed(y%) = 0
            End If
        
            If pl_name$(y%) = "AP_7" Then
                Planets(y%) = 0
                Speed(y%) = 0
            End If
        End If
    Next y%


    Retrograde$ = Space$(NumberOfPlanets%)

    For y% = 1 To NumberOfPlanets%
        If Speed(y%) < 0 Then Mid$(Retrograde$, y%, 1) = "R"
    Next y%
End Sub



Public Function Get_1_Planet(tjd_ut As Double, p_num%) As Double
    Dim ret_flag As Long, x(6) As Double, cusp(13) As Double, ascmc(10) As Double
    Dim iflag As Long, plnam$, retval As Long, serr$, tjd_et As Double
    Dim moon_position As Double, sun_position As Double, chiron_position As Double
    Dim jupiter_position As Double, uranus_position As Double
    Dim nnode_position As Double, transpluto_position As Double
    Dim pof_d_position As Double, pof_n_position As Double
    
    If p_num% > NumberOfPlanets% Then
        If tn_or_tt_or_tnak% = 3 Or tn_or_tt_or_tnak% = 4 Then
            mp_longitude = mp_data(3, p_num% - NumberOfPlanets%)    't. deg to n. deg or Auspicious point or Nakshatra
        ElseIf tn_or_tt_or_tnak% = 2 Then
            mp_longitude = mp_data(3, num_t_deg_to_n_deg%)              'the actual tramsit degree we are searching for
        Else
            Call Get_1_Planet_MIDPOINTS(tjd_ut, p_num%, 1)                 'use separate s/r for midpoints - this is transit
        End If
        
        Get_1_Planet = mp_longitude
        
        Exit Function
    End If
    
    
    tjd_et = tjd_ut + swe_deltat(tjd_ut)

    If Finding_Lucky_Times!optZodiac(1).Value = True Then
        ret_flag = swe_set_sid_mode(SE_SIDM_FAGAN_BRADLEY, 0, 0)
        iflag = SEFLG_SPEED + SEFLG_SWIEPH + SEFLG_SIDEREAL          '258 - for geo tropical
    Else
        iflag = SEFLG_SPEED + SEFLG_SWIEPH          '258 - for geo tropical
    End If
    
    'get individual geo planets
    If pl_type$(p_num%) = "g" Or pl_type$(p_num%) = "t" Or pl_type$(p_num%) = "d" Or pl_type$(p_num%) = "a" Then
        serr$ = String(255, 0)
        plnam$ = String(20, 0)

        ret_flag = swe_calc(tjd_et, pl_ephem_number(p_num%), iflag, x(0), serr$)

        Planets(p_num%) = x(0)
        Speed(p_num%) = x(3)
        
        If p_num% = xSE_S_NODE Then Planets(p_num%) = CRUNCH(Planets(p_num%) + 180)
    End If
    
    
    'get house cusps and some other personal points
    If Finding_Lucky_Times!optHouseSystem(0).Value = True Then
        ret_flag = swe_houses_ex(tjd_ut, iflag, lat, lon, Asc("p"), cusp(0), ascmc(0))         'Placidus
    ElseIf Finding_Lucky_Times!optHouseSystem(1).Value = True Then
        ret_flag = swe_houses_ex(tjd_ut, iflag, lat, lon, Asc("k"), cusp(0), ascmc(0))         'Koch
    ElseIf Finding_Lucky_Times!optHouseSystem(2).Value = True Then
        ret_flag = swe_houses_ex(tjd_ut, iflag, lat, lon, Asc("e"), cusp(0), ascmc(0))         'equal houses from the Asc
    ElseIf Finding_Lucky_Times!optHouseSystem(3).Value = True Then
        ret_flag = swe_houses_ex(tjd_ut, iflag, lat, lon, Asc("e"), cusp(0), ascmc(0))         'equal houses from the Asc
    End If
    
    true_ascendant = ascmc(0)
    
    If pl_type$(p_num%) = "c" Then
        If Finding_Lucky_Times!optHouseSystem(2).Value = True Then
            'I have to make my own whole sign cusps with 0-0 on the cusp
            Planets(p_num%) = Fix(cusp(Val(pl_name$(p_num%))) / 30) * 30
            Speed(p_num%) = 356           'house cusps are never Rx
        Else
            Planets(p_num%) = cusp(Val(pl_name$(p_num%)))
            Speed(p_num%) = 356           'house cusps are never Rx
        End If
    End If


    'now calculate the various "points"
    If pl_type$(p_num%) = "p" Or pl_type$(p_num%) = "l" Then
        If pl_name$(p_num%) = "ASC" Then
            Planets(p_num%) = ascmc(0)
            Speed(p_num%) = 356
        End If
            
        If pl_name$(p_num%) = "MC" Then
            Planets(p_num%) = ascmc(1)
            Speed(p_num%) = 356
        End If
            
        If pl_name$(p_num%) = "EQU_ASC" Then
            Planets(p_num%) = ascmc(4)
            Speed(p_num%) = 356
        End If
            
        If pl_name$(p_num%) = "CO_ASC_WK" Then
            Planets(p_num%) = ascmc(5)
            Speed(p_num%) = 356
        End If
            
        If pl_name$(p_num%) = "CO_ASC_MM" Then
            Planets(p_num%) = ascmc(6)
            Speed(p_num%) = 356
        End If
            
        If pl_name$(p_num%) = "POLAR_ASC" Then
            Planets(p_num%) = ascmc(7)
            Speed(p_num%) = 356
        End If
            
        If pl_name$(p_num%) = "VERTEX" Then
            Planets(p_num%) = ascmc(3)
            Speed(p_num%) = 356
        End If
            
        
        'get planet positions for planets used in Arabic Parts
        ret_flag = swe_calc(tjd_et, pl_ephem_number(xSE_MOON), iflag, x(0), serr$)
        moon_position = x(0)
        
        ret_flag = swe_calc(tjd_et, pl_ephem_number(xSE_SUN), iflag, x(0), serr$)
        sun_position = x(0)
        
        ret_flag = swe_calc(tjd_et, pl_ephem_number(xSE_CHIRON), iflag, x(0), serr$)
        chiron_position = x(0)
        
        ret_flag = swe_calc(tjd_et, pl_ephem_number(xSE_JUPITER), iflag, x(0), serr$)
        jupiter_position = x(0)
        
        ret_flag = swe_calc(tjd_et, pl_ephem_number(xSE_URANUS), iflag, x(0), serr$)
        uranus_position = x(0)
        
        ret_flag = swe_calc(tjd_et, pl_ephem_number(xSE_N_NODE), iflag, x(0), serr$)
        nnode_position = x(0)
        
        ret_flag = swe_calc(tjd_et, pl_ephem_number(xSE_TRANS_PLUTO), iflag, x(0), serr$)
        transpluto_position = x(0)
        
        pof_d_position = CRUNCH(ascmc(0) + moon_position - sun_position)
        
        pof_n_position = CRUNCH(ascmc(0) - moon_position + sun_position)
        
        
        If pl_name$(p_num%) = "POF_d" Then
            Planets(p_num%) = CRUNCH(ascmc(0) + moon_position - sun_position)
            Speed(p_num%) = 356
        End If
            
        If pl_name$(p_num%) = "POF_n" Then
            Planets(p_num%) = CRUNCH(ascmc(0) - moon_position + sun_position)
            Speed(p_num%) = 356
        End If
        
        If pl_name$(p_num%) = "ARIES_PT" Then
            Planets(p_num%) = 0
            Speed(p_num%) = 0
        End If
       
        If pl_name$(p_num%) = "AP_1" Then
            Planets(p_num%) = CRUNCH(ascmc(0) + cusp(5) - chiron_position)
            Speed(p_num%) = 356
        End If
        
        If pl_name$(p_num%) = "AP_2" Then
            Planets(p_num%) = CRUNCH(ascmc(0) + nnode_position - transpluto_position)
            Speed(p_num%) = 356
        End If
        
        If pl_name$(p_num%) = "AP_3" Then
            Planets(p_num%) = CRUNCH(ascmc(0) + jupiter_position - uranus_position)
            Speed(p_num%) = 356
        End If
        
        If pl_name$(p_num%) = "AP_4" Then
            Planets(p_num%) = CRUNCH(ascmc(0) + chiron_position - pof_d_position)
            Speed(p_num%) = 356
        End If
        
        If pl_name$(p_num%) = "AP_5" Then
            Planets(p_num%) = CRUNCH(ascmc(0) + chiron_position - pof_n_position)
            Speed(p_num%) = 356
        End If
        
        If pl_name$(p_num%) = "AP_6" Then
            Planets(p_num%) = 0
            Speed(p_num%) = 356
        End If
        
        If pl_name$(p_num%) = "AP_7" Then
            Planets(p_num%) = 0
            Speed(p_num%) = 356
        End If
    End If
    
    
    Get_1_Planet = Planets(p_num%)
    
    current_speed = Speed(p_num%)
End Function

Public Sub Get_1_Planet_MIDPOINTS(tjd_ut As Double, p_num%, n_t%)
'this routine calculates midpoints and nothing else
    Dim ret_flag As Long, x(6) As Double, cusp(13) As Double, ascmc(10) As Double, z%
    Dim iflag As Long, plnam$, retval As Long, serr$, tjd_et As Double
    Dim moon_position As Double, sun_position As Double, chiron_position As Double
    Dim jupiter_position As Double, uranus_position As Double, nnode_position As Double, transpluto_position As Double
    Dim pof_d_position As Double, pof_n_position As Double, mp1_pos As Double, mp1_speed As Double
    Dim the_longitude As Double, the_speed As Double, the_type$
    Dim lon As Double, lat As Double

    tjd_et = tjd_ut + swe_deltat(tjd_ut)
    
    lon = lon_natal
    lat = lat_natal
    
    If n_t% = 1 Then
        lon = lon_transit
        lat = lat_transit
    End If

    If Finding_Lucky_Times!optZodiac(1).Value = True Then
        ret_flag = swe_set_sid_mode(SE_SIDM_FAGAN_BRADLEY, 0, 0)
        
        iflag = SEFLG_SPEED + SEFLG_SWIEPH + SEFLG_SIDEREAL          '258 - for geo tropical
    Else
        iflag = SEFLG_SPEED + SEFLG_SWIEPH          '258 - for geo tropical
    End If
    
    
    'get house cusps and some other personal points
    If Finding_Lucky_Times!optHouseSystem(0).Value = True Then
        ret_flag = swe_houses_ex(tjd_ut, iflag, lat, lon, Asc("p"), cusp(0), ascmc(0))         'Placidus
    ElseIf Finding_Lucky_Times!optHouseSystem(1).Value = True Then
        ret_flag = swe_houses_ex(tjd_ut, iflag, lat, lon, Asc("k"), cusp(0), ascmc(0))         'Koch
    ElseIf Finding_Lucky_Times!optHouseSystem(2).Value = True Then
        ret_flag = swe_houses_ex(tjd_ut, iflag, lat, lon, Asc("e"), cusp(0), ascmc(0))         'equal houses from the Asc
    ElseIf Finding_Lucky_Times!optHouseSystem(3).Value = True Then
        ret_flag = swe_houses_ex(tjd_ut, iflag, lat, lon, Asc("e"), cusp(0), ascmc(0))         'equal houses from the Asc
    End If
    
    true_ascendant = ascmc(0)
    
    'get planet positions for planets used in Arabic Parts
    ret_flag = swe_calc(tjd_et, pl_ephem_number(xSE_MOON), iflag, x(0), serr$)
    moon_position = x(0)
        
    ret_flag = swe_calc(tjd_et, pl_ephem_number(xSE_SUN), iflag, x(0), serr$)
    sun_position = x(0)
        
    ret_flag = swe_calc(tjd_et, pl_ephem_number(xSE_CHIRON), iflag, x(0), serr$)
    chiron_position = x(0)
        
    ret_flag = swe_calc(tjd_et, pl_ephem_number(xSE_JUPITER), iflag, x(0), serr$)
    jupiter_position = x(0)
        
    ret_flag = swe_calc(tjd_et, pl_ephem_number(xSE_URANUS), iflag, x(0), serr$)
    uranus_position = x(0)
        
    ret_flag = swe_calc(tjd_et, pl_ephem_number(xSE_N_NODE), iflag, x(0), serr$)
    nnode_position = x(0)
        
    ret_flag = swe_calc(tjd_et, pl_ephem_number(xSE_TRANS_PLUTO), iflag, x(0), serr$)
    transpluto_position = x(0)
        
    pof_d_position = CRUNCH(ascmc(0) + moon_position - sun_position)
        
    pof_n_position = CRUNCH(ascmc(0) - moon_position + sun_position)
        
    
    For z% = 0 To 1         'we have to calculate two planets, then find their midpoint at the end
        the_type$ = mp_data(5 + z%, p_num% - NumberOfPlanets%)
        
        'get individual geo planets
        If the_type$ = "g" Or the_type$ = "t" Or the_type$ = "d" Or the_type$ = "a" Then
            serr$ = String(255, 0)
            plnam$ = String(20, 0)

            ret_flag = swe_calc(tjd_et, mp_data(3 + z%, p_num% - NumberOfPlanets%), iflag, x(0), serr$)

            the_longitude = x(0)
            the_speed = x(3)
        
            If mp_data(7 + z%, p_num% - NumberOfPlanets%) = xSE_S_NODE Then the_longitude = CRUNCH(the_longitude + 180)
        End If
    
    
        If the_type$ = "c" Then
            If Finding_Lucky_Times!optHouseSystem(2).Value = True Then
                'I have to make my own whole sign cusps with 0-0 on the cusp
                the_longitude = Fix(cusp(Val(pl_name$(mp_data(7 + z%, p_num% - NumberOfPlanets%)))) / 30) * 30
                the_speed = 356           'house cusps are never Rx
            Else
                the_longitude = cusp(Val(pl_name$(mp_data(7 + z%, p_num% - NumberOfPlanets%))))
                the_speed = 356           'house cusps are never Rx
            End If
        End If


        'now calculate the various "points"
        If the_type$ = "p" Or the_type$ = "l" Then
            If pl_name$(mp_data(7 + z%, p_num% - NumberOfPlanets%)) = "ASC" Then
                the_longitude = ascmc(0)
                the_speed = 356
            End If
            
            If pl_name$(mp_data(7 + z%, p_num% - NumberOfPlanets%)) = "MC" Then
                the_longitude = ascmc(1)
                the_speed = 356
            End If
            
            If pl_name$(mp_data(7 + z%, p_num% - NumberOfPlanets%)) = "EQU_ASC" Then
                the_longitude = ascmc(4)
                the_speed = 356
            End If
            
            If pl_name$(mp_data(7 + z%, p_num% - NumberOfPlanets%)) = "CO_ASC_WK" Then
                the_longitude = ascmc(5)
                the_speed = 356
            End If
            
            If pl_name$(mp_data(7 + z%, p_num% - NumberOfPlanets%)) = "CO_ASC_MM" Then
                the_longitude = ascmc(6)
                the_speed = 356
            End If
            
            If pl_name$(mp_data(7 + z%, p_num% - NumberOfPlanets%)) = "POLAR_ASC" Then
                the_longitude = ascmc(7)
                the_speed = 356
            End If
            
            If pl_name$(mp_data(7 + z%, p_num% - NumberOfPlanets%)) = "VERTEX" Then
                the_longitude = ascmc(3)
                the_speed = 356
            End If


            If pl_name$(mp_data(7 + z%, p_num% - NumberOfPlanets%)) = "POF_d" Then
                the_longitude = CRUNCH(ascmc(0) + moon_position - sun_position)
                the_speed = 356
            End If
            
            If pl_name$(mp_data(7 + z%, p_num% - NumberOfPlanets%)) = "POF_n" Then
                the_longitude = CRUNCH(ascmc(0) - moon_position + sun_position)
                the_speed = 356
            End If
        
            If pl_name$(mp_data(7 + z%, p_num% - NumberOfPlanets%)) = "ARIES_PT" Then
                the_longitude = 0
                the_speed = 0
            End If
       
            If pl_name$(mp_data(7 + z%, p_num% - NumberOfPlanets%)) = "AP_1" Then
                the_longitude = CRUNCH(ascmc(0) + cusp(5) - chiron_position)
                the_speed = 356
            End If
        
            If pl_name$(mp_data(7 + z%, p_num% - NumberOfPlanets%)) = "AP_2" Then
                the_longitude = CRUNCH(ascmc(0) + nnode_position - transpluto_position)
                the_speed = 356
            End If
        
            If pl_name$(mp_data(7 + z%, p_num% - NumberOfPlanets%)) = "AP_3" Then
                the_longitude = CRUNCH(ascmc(0) + jupiter_position - uranus_position)
                the_speed = 356
            End If
        
            If pl_name$(mp_data(7 + z%, p_num% - NumberOfPlanets%)) = "AP_4" Then
                the_longitude = CRUNCH(ascmc(0) + chiron_position - pof_d_position)
                the_speed = 356
            End If
        
            If pl_name$(mp_data(7 + z%, p_num% - NumberOfPlanets%)) = "AP_5" Then
                the_longitude = CRUNCH(ascmc(0) + chiron_position - pof_n_position)
                the_speed = 356
            End If
        
            If pl_name$(mp_data(7 + z%, p_num% - NumberOfPlanets%)) = "AP_6" Then
                the_longitude = 0
                the_speed = 356
            End If
        
            If pl_name$(mp_data(7 + z%, p_num% - NumberOfPlanets%)) = "AP_7" Then
                the_longitude = 0
                the_speed = 356
            End If
        End If
        
        If z% = 0 Then
            mp1_pos = the_longitude
            mp1_speed = the_speed
        End If
    Next z%
    
    
    'now find the midpoint
    mp_longitude = Find_Midpoint(mp1_pos, the_longitude)        'this is the original formula
    
    'but let's try reduction to 30, then finding the midpoint
    If n_t% = 1 And Finding_Lucky_Times!chkAspectarian_reduce_below_30.Value = 1 Then
        mp_longitude = (Reduce_below_30(mp1_pos) + Reduce_below_30(the_longitude)) / 2
    End If
    
    current_speed = (mp1_speed + the_speed) / 2
End Sub


Public Function Find_Midpoint(p1x As Double, p2x As Double)
'diff1 and diff2 added to correct for rounding errors when Sun or Earth is involved in a midpoint calculation
    Dim mp_pos As Double
    Dim diff1 As Single, diff2 As Single

    mp_pos = (p1x + p2x) / 2

'this finds the nearer midpoint, which may not be what is optimum
    diff1 = mp_pos - p1x
    diff2 = mp_pos - p2x

    'If Abs(mp_pos - p1x) > 90 Or Abs(mp_pos - p2x) > 90 Then
    If Abs(diff1) > 90 Or Abs(diff2) > 90 Then mp_pos = mp_pos + 180

    If mp_pos >= 360 Then mp_pos = mp_pos - 360

    Find_Midpoint = mp_pos
End Function


Public Sub Get_Initial_Planet_Positions(ByVal earlier_jd As Double, ByVal later_jd As Double)
    Dim p3 As Integer
    
    p1_pos_later = Get_1_Planet(later_jd, p1)
    p1_pos = Get_1_Planet(earlier_jd, p1)

    If tn_or_tt_or_tnak% >= 5 Then
        'natal midpoint
        p2_pos_later = Natal_MP(p2)
    ElseIf tn_or_tt_or_tnak% = 2 Then
        p2_pos_later = natal_deg_desired                   'this is the longitude - but it must be converted to an angle
        
        p2_pos_later = CRUNCH(natal_deg_desired - Natal(15))           'Natal(15) is the n. Ascendant
        p2_pos = p2_pos_later
    
        'adjust p1 positions so as to take into account the angle difference between calulated Ascendant and desired degree
        p1_pos_later = Get_1_Planet(later_jd, 15)       '15 is the code for natal Ascendant
        p1_pos = Get_1_Planet(earlier_jd, 15)
    Else
        'natal planet
        p2_pos_later = Natal(p2)                                       'transit to natal
    End If
    
    p2_pos = p2_pos_later
    
    If tn_or_tt_or_tnak% = 1 Then
        p2_pos_later = Get_1_Planet(later_jd, p2)          'transit to transit
        p2_pos = Get_1_Planet(earlier_jd, p2)
    ElseIf tn_or_tt_or_tnak% = 3 Or tn_or_tt_or_tnak% = 4 Then
        If p1 > NumberOfPlanets% Then
            p3 = mp_data(8, p1 - NumberOfPlanets%)
        
            p2_pos_later = Get_1_Planet(later_jd, p3)      'Nakshatra to transit
            p2_pos = Get_1_Planet(earlier_jd, p3)
        End If
    End If
End Sub


Public Function Get_separation_for_this_aspect(aspect_num%)
    Dim DA As Double, DAYY As Double, d As Double
    Dim a1 As Double, a2 As Double, b1 As Double
    
    If tn_or_tt_or_tnak% = 2 Then
        a1 = CRUNCH(mp_data(7, p1 - NumberOfPlanets%) - p2_pos)
        
        If p1_pos <= a1 And p1_pos_later > a1 Then
            Get_separation_for_this_aspect = 0.33
        Else
            Get_separation_for_this_aspect = 1000
        End If
        
        Exit Function
    End If
    
    
    'get distance from exact aspect for both planets on JD = later_jd
    DAYY = p2_pos_later - p1_pos_later
    
    DA = Abs(p2_pos_later - p1_pos_later)
    If DA > 180 Then DA = 360 - DA
    
    sep_t1 = DA - aspect_sep!
    If DAYY <= -180 Or (DAYY >= 0 And DAYY < 180) Then sep_t1 = -sep_t1


    'get distance from exact aspect for both planets on JD = earlier_jd
    DAYY = p2_pos - p1_pos

    DA = Abs(p2_pos - p1_pos)
    If DA > 180 Then DA = 360 - DA
    
    
    sep_t0 = DA - aspect_sep!
    If DAYY <= -180 Or (DAYY >= 0 And DAYY < 180) Then sep_t0 = -sep_t0

    If sep_t1 - sep_t0 = 0 Then
        d = 1000
    Else
        d = sep_t1 / (sep_t1 - sep_t0)     'since our interval is always 1 day
    End If

    Get_separation_for_this_aspect = d
End Function

Sub SecantMethod(ByVal earlier_jd As Double, ByVal later_jd As Double, ByVal e As Double, ByVal m As Integer)
    Dim DA As Double, DAYY As Double, n As Integer, d As Double
    Dim Y1 As Double, Y2 As Double, y3 As Double, y4 As Double
    Dim dist1 As Double, dist2 As Double, p3 As Integer
    
    For n = 1 To m
        Y1 = Get_1_Planet(later_jd, p1)
        p1_current_speed = current_speed
        y3 = Get_1_Planet(earlier_jd, p1)

        If tn_or_tt_or_tnak% >= 5 Then
            'natal midpoint
            Y2 = Natal_MP(p2)
        ElseIf tn_or_tt_or_tnak% = 2 Then
            'do nothing
        Else
            Y2 = Natal(p2)                                               'transit to natal
        End If
        
        y4 = Y2

        If tn_or_tt_or_tnak% = 1 Then
            Y2 = Get_1_Planet(later_jd, p2)                   'transit to transit
            y4 = Get_1_Planet(earlier_jd, p2)
        ElseIf tn_or_tt_or_tnak% = 2 Then
            Y1 = Get_1_Planet(later_jd, 15)                     '15 is the code for t. Ascendant
            p1_current_speed = current_speed
            y3 = Get_1_Planet(earlier_jd, 15)
            
            Y2 = CRUNCH(mp_data(7, p1 - NumberOfPlanets%) - p2_pos)
            y4 = Y2
        ElseIf tn_or_tt_or_tnak% = 3 Or tn_or_tt_or_tnak% = 4 Then
            If p1 > NumberOfPlanets% Then
                p3 = mp_data(8, p1 - NumberOfPlanets%)
        
                Y2 = Get_1_Planet(later_jd, p3)               'Nakshatra to transit
                y4 = Get_1_Planet(earlier_jd, p3)
            End If
        End If

        
        'get distance from exact aspect for both planets on JD = later_jd
        DAYY = Y2 - Y1
        
        DA = Abs(Y2 - Y1)
        If DA > 180 Then DA = 360 - DA
        
        dist1 = DA - aspect_sep!
        If DAYY <= -180 Or (DAYY >= 0 And DAYY < 180) Then dist1 = -dist1

        
        'get distance from exact aspect for both planets on JD = earlier_jd
        DAYY = y4 - y3
        
        DA = Abs(y4 - y3)
        If DA > 180 Then DA = 360 - DA
        
        dist2 = DA - aspect_sep!
        If DAYY <= -180 Or (DAYY >= 0 And DAYY < 180) Then dist2 = -dist2

        
        If dist1 - dist2 = 0 Then
            later_jd = (later_jd + earlier_jd) / 2
            d = 0
        Else
            d = ((later_jd - earlier_jd) / (dist1 - dist2)) * dist1
        End If

        If Abs(dist1 - dist2) > 20 And n >= 2 Then
            'keep from looping needlessly AND protect against case where dist1 = -dist2, which gives false aspect
            'example 21 March 2006 - Moon 120 Mars - there is no trine, but an opposition
            later_jd = 0
            
            Exit For
        End If

        If Abs(d) < e Then
            Exit For
        End If

        earlier_jd = later_jd

        If Abs(d) >= 1.001 Then
            'out of range - there is no aspect in this time frame (1 day)
            later_jd = 0

            Exit For
        Else
            later_jd = later_jd - d
        End If
    Next n

    If n > m Then
        Result_JD = 0
    Else
        Result_JD = later_jd
    End If
End Sub

Sub SecantMethod_specific_longitude(ByVal earlier_jd As Double, ByVal later_jd As Double, ByVal e As Double, ByVal m As Integer, longitude_to_find As Double)
    Dim DA As Double, DAYY As Double, n As Integer, d As Double
    Dim Y1 As Double, Y2 As Double, y3 As Double, y4 As Double
    Dim dist1 As Double, dist2 As Double, p3 As Integer
    
    For n = 1 To m
        Y1 = Get_1_Planet(later_jd, p1)
        p1_current_speed = current_speed
        y3 = Get_1_Planet(earlier_jd, p1)

        Y2 = longitude_to_find                                    'transit to natal
        y4 = Y2

        If tn_or_tt_or_tnak% = 1 Then
            Y2 = Get_1_Planet(later_jd, p2)                   'transit to transit
            y4 = Get_1_Planet(earlier_jd, p2)
        ElseIf tn_or_tt_or_tnak% = 2 Or tn_or_tt_or_tnak% = 3 Or tn_or_tt_or_tnak% = 4 Then
            If p1 > NumberOfPlanets% Then
                p3 = mp_data(8, p1 - NumberOfPlanets%)
        
                Y1 = Get_1_Planet(later_jd, p3)               'Nakshatra to transit
                y3 = Get_1_Planet(earlier_jd, p3)
            End If
        End If

        
        'get distance from exact aspect for both planets on JD = later_jd
        DAYY = Y2 - Y1
        
        DA = Abs(Y2 - Y1)
        If DA > 180 Then DA = 360 - DA
        
        dist1 = DA
        If DAYY <= -180 Or (DAYY >= 0 And DAYY < 180) Then dist1 = -dist1

        
        'get distance from exact aspect for both planets on JD = earlier_jd
        DAYY = y4 - y3
        
        DA = Abs(y4 - y3)
        If DA > 180 Then DA = 360 - DA
        
        dist2 = DA
        If DAYY <= -180 Or (DAYY >= 0 And DAYY < 180) Then dist2 = -dist2

        
        If dist1 - dist2 = 0 Then
            later_jd = (later_jd + earlier_jd) / 2
            d = 0
        Else
            d = ((later_jd - earlier_jd) / (dist1 - dist2)) * dist1
        End If

        If Abs(dist1 - dist2) > 20 And n >= 2 Then
            'keep from looping needlessly AND protect against case where dist1 = -dist2, which gives false aspect
            'example 21 March 2006 - Moon 120 Mars - there is no trine, but an opposition
            later_jd = 0
            
            Exit For
        End If

        If Abs(d) < e Then
            Exit For
        End If

        earlier_jd = later_jd

        If Abs(d) >= 1.001 Then
            'out of range - there is no aspect in this time frame (1 day)
            later_jd = 0

            Exit For
        Else
            later_jd = later_jd - d
        End If
    Next n

    If n > m Then
        Result_JD = 0
    Else
        Result_JD = later_jd
    End If
End Sub


Sub SecantMethod_transit_to_transit(ByVal earlier_jd As Double, ByVal later_jd As Double, ByVal e As Double, ByVal m As Integer, asp_idx%, asp_sep As Double)
'asp_sep! = the exact ditacne between two planets we are looking for
'asp_idx% = index into chkAspects(asp_idx%), which give us the exact angle
    Dim DA As Double, DAYY As Double, n As Integer, d As Double
    Dim Y1 As Double, Y2 As Double, y3 As Double, y4 As Double
    Dim dist1 As Double, dist2 As Double, p3 As Integer
    
    For n = 1 To m
        Y1 = Get_1_Planet(later_jd, p1)
        p1_current_speed = current_speed
        y3 = Get_1_Planet(earlier_jd, p1)

        Y2 = Get_1_Planet(later_jd, p2)                   'transit to transit
        y4 = Get_1_Planet(earlier_jd, p2)

        
        'get distance from exact aspect for both planets on JD = later_jd
        DAYY = Y2 - Y1
        
        DA = Abs(Y2 - Y1)
        'If asp_idx% <> 0 And asp_idx% <> 14 Then       'not sure why this is here for conjunctions and oppositions
            If DA > 180 Then DA = 360 - DA
        'End If
        
        dist1 = DA - asp_sep
        If asp_idx% <> 0 And asp_idx% <> 14 Then
            If DAYY <= -180 Or (DAYY >= 0 And DAYY < 180) Then dist1 = -dist1
        End If

        
        'get distance from exact aspect for both planets on JD = earlier_jd
        DAYY = y4 - y3
        
        DA = Abs(y4 - y3)
        'If asp_idx% <> 0 And asp_idx% <> 14 Then       'not sure why this is here for conjunctions and oppositions
            If DA > 180 Then DA = 360 - DA
        'End If
        
        dist2 = DA - asp_sep
        If asp_idx% <> 0 And asp_idx% <> 14 Then
            If DAYY <= -180 Or (DAYY >= 0 And DAYY < 180) Then dist2 = -dist2
        End If

        
        If dist1 - dist2 = 0 Then
            later_jd = (later_jd + earlier_jd) / 2
            d = 0
        Else
            d = ((later_jd - earlier_jd) / (dist1 - dist2)) * dist1
        End If

        If Abs(dist1 - dist2) > 20 And n >= 2 Then
            'keep from looping needlessly AND protect against case where dist1 = -dist2, which gives false aspect
            'example 21 March 2006 - Moon 120 Mars - there is no trine, but an opposition
            later_jd = 0
            
            Exit For
        End If

        If Abs(d) < e Then
            Exit For
        End If

        earlier_jd = later_jd

        If Abs(d) >= 1.001 Then
        'If Abs(d) >= 1.003 Then
            'out of range - there is no aspect in this time frame (1 day)
            later_jd = 0

            Exit For
        Else
            later_jd = later_jd - d
        End If
    Next n

    If n > m Then
        Result_JD = 0
    Else
        Result_JD = later_jd
    End If
End Sub



Sub ConvertJDtoDateandTime(XjdX As Double)
'Date is stored in JDDate$ and time is stored in JDTime$
    Dim fraction As Double, hh As Integer, mm As Integer, sd As Date
    Dim temp_JD As Double, t1$, y7 As Long, m7 As Long, d7 As Long, h7 As Double

    temp_JD = XjdX - (Val(Finding_Lucky_Times!txtDiurnalTZ.Text) / 24)
    Call swe_revjul(temp_JD + 0.000001, 1, y7, m7, d7, h7)

    'JDDate$ = Format$(m7 & "/" & d7 & "/" & y7, "mm/dd/yyyy")
    
    If MyiDate% = 0 Then
        'JDDate$ = Format$(m7 & "/" & d7 & "/" & y7, "mm/dd/yyyy")
        JDDate$ = Format$(m7, "00") & "/" & Format$(d7, "00") & "/" & Format$(y7, "0000")
    ElseIf MyiDate% = 1 Then
        'JDDate$ = Format$(m7 & "/" & d7 & "/" & y7, "dd/mm/yyyy")
        JDDate$ = Format$(d7, "00") & "/" & Format$(m7, "00") & "/" & Format$(y7, "0000")
    ElseIf MyiDate% = 2 Then
        'JDDate$ = Format$(m7 & "/" & d7 & "/" & y7, "yyyy/mm/dd")
        JDDate$ = Format$(y7, "0000") & "/" & Format$(m7, "00") & "/" & Format$(d7, "00")
    End If
    
    JDTime$ = Format$(h7 / 24, "hh:nn:ss")

    If JDTime$ = "24:00:00" Then
        JDTime$ = "00:00:00"
        
        sd = JDDate$
        sd = sd + 1
        
        JDDate$ = sd
        Calendar$ = sd
    End If
End Sub

Public Sub Get_Planet_Positions_at_Exact(p1 As Integer, p2 As Integer, ByVal JD As Double)
'get positions of both planets on JD
    Dim p3 As Integer
    
    p1_pos = Get_1_Planet(JD, p1)
    p1_exact_speed = current_speed
    
    If tn_or_tt_or_tnak% = 2 Or tn_or_tt_or_tnak% = 3 Or tn_or_tt_or_tnak% = 4 Then p1_exact_speed = 0

    
    If tn_or_tt_or_tnak% >= 5 Then
        'natal midpoints
        p2_pos = Natal_MP(p2)
        p2_exact_speed = Natal_MP_Speed(p2)
    ElseIf tn_or_tt_or_tnak% = 2 Then
        'do nothing
    Else
        p2_pos = Natal(p2)                                       'transit to natal
        p2_exact_speed = NatalSpeed(p2)
    End If

    
    If tn_or_tt_or_tnak% = 1 Then
        p2_pos = Get_1_Planet(JD, p2)                  'transit to transit
        p2_exact_speed = current_speed
    ElseIf tn_or_tt_or_tnak% = 2 Or tn_or_tt_or_tnak% = 3 Or tn_or_tt_or_tnak% = 4 Then
        If p1 > NumberOfPlanets% Then
            p3 = mp_data(8, p1 - NumberOfPlanets%)
        
            p2_pos = Get_1_Planet(JD, p3)               'Nakshatra to transit
            p2_exact_speed = current_speed
        End If
    End If
End Sub


Public Sub Calculate_natal_midpoint_longitudes()
    Dim cnt%, x%
    
    cnt% = NumberOfPlanets% + num_t_deg_to_n_deg% + num_auspicious_points% + num_lunar_mansions% + num_t_to_n_midpoints% + num_t_to_t_midpoints% + num_natal_midpoints%
    
    ReDim Natal_MP(NumberOfPlanets% + 1 To cnt%)
    ReDim Natal_MP_Speed(NumberOfPlanets% + 1 To cnt%)
    
    For x% = NumberOfPlanets% + 1 To NumberOfPlanets% + num_natal_midpoints% + num_t_to_n_midpoints% + num_t_to_t_midpoints%
        Call Get_1_Planet_MIDPOINTS(NatalJD, x%, 0)                  'use separate s/r for midpoints - this is natal
        
        Natal_MP(x%) = mp_longitude
        Natal_MP_Speed(x%) = current_speed
    Next x%
End Sub
