Attribute VB_Name = "Module6"
Option Explicit


Public Sub Get_declination_aspects(start_JD As Double, end_JD As Double)
'this is always transit planet to natal planet
    Dim x As Double, y As Single, z As Integer
    Dim rnd_off As Double, sJD As Double, eJD As Double, separation As Double, vjd%
    
    For p1 = 1 To NumberOfPlanets%
        If Finding_Lucky_Times!chkP1Planets(p1 - 1).Value = 0 Then GoTo skip_p1
        
        If pl_type$(p1) = "c" Or pl_type$(p1) = "p" Or pl_type$(p1) = "l" Then GoTo skip_p1

        For p2 = 1 To NumberOfPlanets%
            If Finding_Lucky_Times!chkP2Planets(p2 - 1).Value = 0 Then GoTo skip_p2
            
            If pl_type$(p2) = "c" Or pl_type$(p2) = "p" Or pl_type$(p2) = "l" Then GoTo skip_p2

            For x = start_JD To end_JD
                Call Get_Initial_Planet_Positions_DECL(x, x + 1)
                
                'check for zero crossing of declination
                Result_JD_p1_cross = Find_if_zero_cross_during_time_period(x, x + 1, p1)
                
                Result_JD_p2_cross = 0
                
                ReDim JDs_to_process(1 To 2)
                
                num_JDs = 2
                
                JDs_to_process(1) = x
                JDs_to_process(2) = x + 1

                If Result_JD_p1_cross > 0 Then
                    num_JDs = num_JDs + 1
                    ReDim Preserve JDs_to_process(1 To num_JDs)
                    JDs_to_process(num_JDs) = Result_JD_p1_cross
                End If
                
                If Result_JD_p2_cross > 0 Then
                    num_JDs = num_JDs + 1
                    ReDim Preserve JDs_to_process(1 To num_JDs)
                    JDs_to_process(num_JDs) = Result_JD_p2_cross
                End If
                
                
                'check for change in declination direction
                Result_JD_p1_cross = Find_if_max_declination_during_time_period(x, x + 1, p1)
                
                Result_JD_p2_cross = 0
                
                If Result_JD_p1_cross > 0 Then
                    num_JDs = num_JDs + 1
                    ReDim Preserve JDs_to_process(1 To num_JDs)
                    JDs_to_process(num_JDs) = Result_JD_p1_cross
                End If
                
                If Result_JD_p2_cross > 0 Then
                    num_JDs = num_JDs + 1
                    ReDim Preserve JDs_to_process(1 To num_JDs)
                    JDs_to_process(num_JDs) = Result_JD_p2_cross
                End If

                
                'sort the JDs in ascending order
                Call Sort_the_JDs
                
                For vjd% = 1 To num_JDs - 1
                    sJD = JDs_to_process(vjd%)
                    eJD = JDs_to_process(vjd% + 1)
                
                    For z = num_aspects% - 1 To num_aspects%
                        If Finding_Lucky_Times!chkAspects(z).Value = 1 Then
                            aspect_sep! = Val(Finding_Lucky_Times!chkAspects(z).Caption)
                            separation = Get_separation_for_this_aspect_DECL(z)

                            If Abs(separation) < 1.001 Then
                                Call SecantMethod_DECL(sJD, eJD, 0.000007, 100, z)

                                'rnd_off = Val(Format$(Result_JD, "0.000"))
                                rnd_off = Result_JD
                                If rnd_off >= sJD And rnd_off <= eJD Then
                                    'Call ConvertJDtoDateandTime(Result_JD)
                                    Call ConvertJDtoDateandTime(Result_JD)
                                
                                    'store aspects found in an array
                                    aspects$(0, num_found_aspects%) = p1
                                    aspects$(2, num_found_aspects%) = p2

                                    aspects$(1, num_found_aspects%) = z
                                    aspects$(3, num_found_aspects%) = JDDate$ & " " & JDTime$
                                    'aspects$(4, num_found_aspects%) = Format$(p1_current_speed, "0.0000")

                                    'get planet positions at exact time
                                    p1_pos_dl = Get_1_Planet_decl(Result_JD, p1)
                                    p2_pos_dl = Natal_Decl(p2)
                                    
                                    aspects$(5, num_found_aspects%) = p1_pos_dl
                                    aspects$(6, num_found_aspects%) = p2_pos_dl
                                    
                                    aspects$(7, num_found_aspects%) = current_speed
                                    
                                    aspects$(9, num_found_aspects%) = Result_JD
                                    
                                    aspects$(10, num_found_aspects%) = "d"

                                    num_found_aspects% = num_found_aspects% + 1
                                    ReDim Preserve aspects$(0 To num_aspect_elements%, num_found_aspects%)

                                    Call Get_Initial_Planet_Positions_DECL(x, x + 1)   'so we can get back the original value of p1_pos_dl
                                End If
                            End If
                        End If
                    Next z
                Next vjd%
            Next x
skip_p2:
        Next p2
skip_p1:
    Next p1
End Sub

Public Function Find_if_max_declination_during_time_period(ByVal earlier_jd As Double, ByVal later_jd As Double, p1 As Integer) As Double
    Dim jdjd As Double, spd1 As Double, spd2 As Double, Y1 As Double, y3 As Double

'must check type of calculation, then do proper one (geo or helio)
    Y1 = Get_1_Planet_decl(later_jd, p1)
    spd1 = current_speed
    
    Y1 = Get_1_Planet_decl(earlier_jd, p1)
    spd2 = current_speed

    If Sgn(spd1) <> Sgn(spd2) Then
        jdjd = Get_exact_time_of_max_decl_2(earlier_jd, p1)
    Else
        jdjd = 0
    End If

    Find_if_max_declination_during_time_period = jdjd
End Function

Public Function Get_exact_time_of_max_decl_2(ByVal given_jd As Double, p1 As Integer) As Double
    Dim spd1 As Double, spd3 As Double, x As Double, Y1 As Double, y3 As Double, z As Double, zz As Double

    For x = given_jd To given_jd + 1 Step 1 / 24
        Y1 = Get_1_Planet_decl(x + 1 / 24, p1)
        spd1 = current_speed
            
        y3 = Get_1_Planet_decl(x, p1)
        spd3 = current_speed

        If Sgn(spd1) = Sgn(spd3) Then
            GoTo continue_loop
        Else
            For z = x To x + 60 / 1440 Step 1 / 1440                'find the minute of exact
                Y1 = Get_1_Planet_decl(z + 1 / 1440, p1)
                spd1 = current_speed
                    
                y3 = Get_1_Planet_decl(z, p1)
                spd3 = current_speed

                If Sgn(spd1) = Sgn(spd3) Then GoTo cont_loop

                For zz = z To z + 3600 / 86400 Step 1 / 86400             'find the second of exact
                    Y1 = Get_1_Planet_decl(zz + 1 / 86400, p1)
                    spd1 = current_speed
                        
                    y3 = Get_1_Planet_decl(zz, p1)
                    spd3 = current_speed

                    If Sgn(spd1) = Sgn(spd3) Then GoTo cont_loop1

                    Get_exact_time_of_max_decl_2 = zz
                    
                    Exit Function
cont_loop1:
                Next zz
cont_loop:
            Next z
        End If
continue_loop:
    Next x

    
    Get_exact_time_of_max_decl_2 = 0            'error - should never get here
    
    Stop
End Function



Public Function Find_if_zero_cross_during_time_period(ByVal earlier_jd As Double, ByVal later_jd As Double, p1 As Integer) As Double
    Dim jdjd As Double, Y1 As Double, y3 As Double

'must check type of calculation, then do proper one (geo or helio)
    Y1 = Get_1_Planet_decl(later_jd, p1)
    y3 = Get_1_Planet_decl(earlier_jd, p1)

    If Sgn(Y1) <> Sgn(y3) Then
        jdjd = Get_exact_time_of_zero_crossing(earlier_jd, p1)
    Else
        jdjd = 0
    End If

    Find_if_zero_cross_during_time_period = jdjd
End Function


Public Function Get_exact_time_of_zero_crossing(ByVal given_jd As Double, p1 As Integer) As Double
    Dim x As Double, Y1 As Double, y3 As Double, z As Double, zz As Double

    For x = given_jd To given_jd + 1 Step 1 / 24
        'must check type of calculation, then do proper one (geo or helio)
        Y1 = Get_1_Planet_decl(x + 1 / 24, p1)
        y3 = Get_1_Planet_decl(x, p1)

        If Sgn(Y1) = Sgn(y3) Then
            GoTo continue_loop
        Else
            For z = x To x + 60 / 1440 Step 1 / 1440                'find the minute of exact
                Y1 = Get_1_Planet_decl(z + 1 / 1440, p1)
                y3 = Get_1_Planet_decl(z, p1)

                If Sgn(Y1) = Sgn(y3) Then GoTo cont_loop

                For zz = z To z + 3600 / 86400 Step 1 / 86400             'find the second of exact
                    Y1 = Get_1_Planet_decl(zz + 1 / 86400, p1)
                    y3 = Get_1_Planet_decl(zz, p1)

                    If Sgn(Y1) = Sgn(y3) Then GoTo cont_loop1

                    Get_exact_time_of_zero_crossing = zz
                    
                    Exit Function
cont_loop1:
                Next zz
cont_loop:
            Next z
        End If
continue_loop:
    Next x

    
    Get_exact_time_of_zero_crossing = 0            'error - should never get here
    
    Stop
End Function

Function Get_1_Planet_decl(givenJD As Double, p_num%)
    Dim ret_flag As Long, serr$, x(6) As Double
    Dim et As Double, ut As Double, iflag As Long

    ut = givenJD

    et = ut + swe_deltat(givenJD)

    serr$ = String(255, 0)

    If Finding_Lucky_Times!optZodiac(1).Value = True Then
        ret_flag = swe_set_sid_mode(SE_SIDM_FAGAN_BRADLEY, 0, 0)
        iflag = 2 + 256 + 2048 + SEFLG_SIDEREAL          '258 - for geo tropical
    Else
        iflag = 2 + 256 + 2048                                        '258 - for geo tropical
    End If
    
    ret_flag = swe_calc(et, pl_ephem_number(p_num%), iflag, x(0), serr$)

    Get_1_Planet_decl = x(1)

    current_speed = x(4)
End Function

Public Sub Get_all_planet_positions_DECL()
    Dim cal As Byte, ret_flag As Long, y%
    Dim x(6) As Double, cusp(13) As Double, ascmc(10) As Double
    Dim iflag As Long, retval As Long, serr$, tjd_et As Double

' the next two functions do the same job, converting a calendar date into a Julian day number
' swe_date_conversion() checks for legal dates while swe_julday() handles
' even illegal things like 45 Januar etc.
    cal = 103       'g for Gregorian calendar

    h = ihour! + imin! / 60#
    tjd_ut = swe_julday(iyear%, imonth%, iday%, h, 1)
    retval = swe_date_conversion(iyear, imonth, iday, h, cal, tjd_ut)

    tjd_et = tjd_ut + swe_deltat(tjd_ut)

    iflag = 2 + 256 + 2048

    For y% = 1 To NumberOfPlanets%
        If pl_type$(y%) = "g" Or pl_type$(y%) = "t" Or pl_type$(y%) = "d" Or pl_type$(y%) = "a" Then
            serr$ = String(255, 0)

            ret_flag = swe_calc(tjd_et, pl_ephem_number(y%), iflag, x(0), serr$)
            
            Natal_Decl(y%) = x(1)
            
            If y% = xSE_S_NODE Then Natal_Decl(y%) = -Natal_Decl(y%)
        End If
    Next y%
End Sub




Public Sub Sort_the_JDs()
    Dim x%, y%, z As Double

    For x% = 1 To num_JDs - 1
        For y% = x% + 1 To num_JDs
            If JDs_to_process(y%) < JDs_to_process(x%) Then
                z = JDs_to_process(x%)
                JDs_to_process(x%) = JDs_to_process(y%)
                JDs_to_process(y%) = z
            End If
        Next y%
    Next x%
End Sub

Public Sub Get_Initial_Planet_Positions_DECL(ByVal earlier_jd As Double, ByVal later_jd As Double)
'get positions of both planets on JD = later_jd and JD = earlier_jd
    p1_pos_later_dl = Get_1_Planet_decl(later_jd, p1)
    p1_pos_dl = Get_1_Planet_decl(earlier_jd, p1)

    'transit to natal
    p2_pos_later_dl = Natal_Decl(p2)
    p2_pos_dl = Natal_Decl(p2)
End Sub

Public Function Get_separation_for_this_aspect_DECL(aspect_num%)
    Dim DA As Double, DAYY As Double, d As Double

    If aspect_num% = num_aspects% - 1 Then
        'get distance from exact aspect for both planets on JD = later_jd
        sep_t1 = p2_pos_later_dl - p1_pos_later_dl

        'get distance from exact aspect for both planets on JD = earlier_jd
        sep_t0 = p2_pos_dl - p1_pos_dl
    Else
        'get distance from exact aspect for both planets on JD = later_jd
        sep_t1 = Abs(p2_pos_later_dl) - Abs(p1_pos_later_dl)

        'get distance from exact aspect for both planets on JD = earlier_jd
        sep_t0 = Abs(p2_pos_dl) - Abs(p1_pos_dl)
    End If

    If sep_t1 - sep_t0 = 0 Then
        d = 1000
    Else
        d = sep_t1 / (sep_t1 - sep_t0)     'since our interval is always 1 day
    End If

    Get_separation_for_this_aspect_DECL = d
End Function


Sub SecantMethod_DECL(ByVal earlier_jd As Double, ByVal later_jd As Double, ByVal e As Double, ByVal m As Integer, aspect_num%)
    Dim DA As Double, DAYY As Double, n As Integer, d As Double
    Dim Y1 As Double, Y2 As Double, y3 As Double, y4 As Double
    Dim dist1 As Double, dist2 As Double

    For n = 1 To m
        'get positions of both planets on JD = later_jd and JD = earlier_jd
        Y1 = Get_1_Planet_decl(later_jd, p1)
        p1_current_speed = current_speed
        y3 = Get_1_Planet_decl(earlier_jd, p1)

        'transit to natal
        Y2 = Natal_Decl(p2)
        y4 = Y2

        If aspect_num% = num_aspects% - 1 Then
            'get distance from exact aspect for both planets on JD = later_jd
            dist1 = Y2 - Y1

            'get distance from exact aspect for both planets on JD = earlier_jd
            dist2 = y4 - y3
        Else
            'get distance from exact aspect for both planets on JD = later_jd
            dist1 = Abs(Y2) - Abs(Y1)

            'get distance from exact aspect for both planets on JD = earlier_jd
            dist2 = Abs(y4) - Abs(y3)
        End If

        If dist1 - dist2 = 0 Then
            later_jd = (later_jd + earlier_jd) / 2
            d = 0
        Else
            d = ((later_jd - earlier_jd) / (dist1 - dist2)) * dist1
        End If

        If Abs(dist1 - dist2) > 20 And n >= 2 Then
            'keep from looping needlessly AND
            'protect against case where dist1 = -dist2, which gives false aspect
            'example 21 March 2006 - Moon 120 Mars - there is no trine, but an opposition
            later_jd = 0
            
            Exit For
        End If

        If Abs(d) < e Then
            'check to see if this is a parallel or a contra-parallel
            Y1 = Get_1_Planet_decl(later_jd, p1)
            Y2 = Natal_Decl(p2)

            If (aspect_num% = num_aspects% - 1) And ((Y1 >= 0 And Y2 < 0) Or (Y1 < 0 And Y2 >= 0)) Then
                'this doesn't appear to be needed because of the math
                later_jd = 0
            End If

            If (aspect_num% = num_aspects%) And ((Y1 >= 0 And Y2 >= 0) Or (Y1 < 0 And Y2 < 0)) Then
                'this does need to be here
                later_jd = 0
            End If

            Exit For
        End If

        earlier_jd = later_jd

        If Abs(d) >= 1.001 Then
            'out of range - there is no aspect in this time frame (1 day)
            later_jd = 0
            Exit For
        Else
            later_jd = later_jd - d
        End If
    Next n

    If n > m Then
        Result_JD = 0
    Else
        Result_JD = later_jd
    End If
End Sub


Public Sub Get_enter_and_exit_times_and_positions_DECL(y%, offset_app As Double, offset_sep As Double)
'y% = grid record we need to find data for
'take the JD info and other info in grid_aspects$() and use it to find enter orb and exit orb date and time
'then insert the data into the grid in the correct columns
    Dim a1 As Double, a2 As Double, aspect_num%, t$, x As Double
    Dim declination_to_find As Double, days_to_move As Double, exact_jd As Double, spd1 As Double
    Dim diff_p1_p2 As Double, p1_pos As Double, p2_pos As Double, separation As Double
    Dim base_declination As Double, days_forward_back As Single
    
    days_forward_back = Val(Finding_Lucky_Times!txtDaysForwardBack.Text)
    
    spd1 = grid_aspects$(7, y%)
        
    If spd1 <> 0 Then
        days_to_move = offset_app / spd1        'roughly how many days it will take this t. planet to cover the distance for applying
        
        If Abs(days_to_move) > num_days_for_aspectarian% + 3 Then GoTo next_y    'this planet is too slow to calculate
    Else
        'GoTo next_y               'this t. planet is stationary, so I am not going to calculate
    End If
        
    p1 = grid_aspects$(0, y%)
    p2 = grid_aspects$(2, y%)
        
    aspect_num% = grid_aspects$(1, y%)
    
    p1_pos = grid_aspects$(5, y%)
    p2_pos = grid_aspects$(6, y%)
        
    diff_p1_p2 = Abs(Abs(p1_pos) - Abs(p2_pos))
        
        
    'instead of using the base angle, let's just get the base declination was actually want to find - this is the integer part
    'of the transit planet and the fractional part of the natal planet
    base_declination = Int(p1_pos) + Abs(p2_pos - Int(p2_pos))          'this WAS "Fix", but that rounds incorrectly for negative numbers
        
    exact_jd = grid_aspects$(9, y%)
        
    jd_increment = 1                                              'every day is good enough
        
    tn_or_tt_or_tnak% = 0
        
        
    'now adjust this base_declination by the offset_app/offset_sep to get the actual declination we need
    'do applying towards exact
    If spd1 >= 0 Then
        If p1_pos < p2_pos Then
            declination_to_find = base_declination - offset_app
        ElseIf p1_pos >= p2_pos Then
            declination_to_find = base_declination - offset_app
        End If
    ElseIf spd1 < 0 Then
        If p1_pos < p2_pos Then
            declination_to_find = base_declination + offset_app
        ElseIf p1_pos >= p2_pos Then
            declination_to_find = base_declination + offset_app
        End If
    End If
        
    'find when t. planet enters the specified orb - but only look back 2 days
    a1 = exact_jd - days_forward_back
    a2 = exact_jd
        
    If spd1 = 0 Then
        a1 = exact_jd - (6 / 1440)
        a2 = exact_jd
    End If
        
    For x = a2 To a1 Step -jd_increment
        Call SecantMethod_specific_declination(x - jd_increment, x, 0.00000035, 100, declination_to_find, aspect_num%)

        If Result_JD >= x - jd_increment And Result_JD <= x Then
            Call ConvertJDtoDateandTime(Result_JD)

            'enter data into grid
            Grid_form!grdOutput.row = y%
            Grid_form!grdOutput.col = 11
            Grid_form!grdOutput.Text = JDDate$ & " " & JDTime$

            Exit For
        End If
    Next x
        
        
    'do separation from exact
    If spd1 >= 0 Then
        If p1_pos < p2_pos And diff_p1_p2 >= 180 Then
            declination_to_find = base_declination + offset_sep
        ElseIf p1_pos < p2_pos And diff_p1_p2 < 180 Then
            declination_to_find = base_declination + offset_sep
        ElseIf p1_pos >= p2_pos And diff_p1_p2 >= 180 Then
            declination_to_find = base_declination + offset_sep
        ElseIf p1_pos >= p2_pos And diff_p1_p2 < 180 Then
            declination_to_find = base_declination + offset_sep
        End If
    ElseIf spd1 < 0 Then
        If p1_pos < p2_pos And diff_p1_p2 >= 180 Then
            declination_to_find = base_declination - offset_sep
        ElseIf p1_pos < p2_pos And diff_p1_p2 < 180 Then
            declination_to_find = base_declination - offset_sep
        ElseIf p1_pos >= p2_pos And diff_p1_p2 >= 180 Then
            declination_to_find = base_declination - offset_sep
        ElseIf p1_pos >= p2_pos And diff_p1_p2 < 180 Then
            declination_to_find = base_declination - offset_sep
        End If
    End If
        
    'find when t. planet enters the specified orb - but only look ahead 2 days
    a1 = exact_jd
    a2 = exact_jd + days_forward_back
        
    If spd1 = 0 Then
        a1 = exact_jd
        a2 = exact_jd + (6 / 1440)
    End If
        
    For x = a1 To a2 + 2 Step jd_increment
        Call SecantMethod_specific_declination(x, x + jd_increment, 0.00000035, 100, declination_to_find, aspect_num%)

        If Result_JD >= x And Result_JD <= x + jd_increment Then
            Call ConvertJDtoDateandTime(Result_JD)
                        
            'enter data into grid
            Grid_form!grdOutput.row = y%
            Grid_form!grdOutput.col = 13
            Grid_form!grdOutput.Text = JDDate$ & " " & JDTime$
                
                
            Exit For
        End If
    Next x
next_y:
End Sub

Sub SecantMethod_specific_declination(ByVal earlier_jd As Double, ByVal later_jd As Double, ByVal e As Double, ByVal m As Integer, declination_to_find As Double, aspect_num%)
    Dim DA As Double, DAYY As Double, n As Integer, d As Double
    Dim Y1 As Double, Y2 As Double, y3 As Double, y4 As Double
    Dim dist1 As Double, dist2 As Double
    
    For n = 1 To m
        Y1 = Get_1_Planet_decl(later_jd, p1)
        p1_current_speed = current_speed
        y3 = Get_1_Planet_decl(earlier_jd, p1)

        Y2 = declination_to_find                                          'transit to natal
        y4 = Y2

        If tn_or_tt_or_tnak% = 1 Then
            Y2 = Get_1_Planet_decl(later_jd, p2)                   'transit to transit
            y4 = Get_1_Planet_decl(earlier_jd, p2)
        End If

        
        If aspect_num% = num_aspects% - 1 Then
            'get distance from exact aspect for both planets on JD = later_jd
            dist1 = Y2 - Y1

            'get distance from exact aspect for both planets on JD = earlier_jd
            dist2 = y4 - y3
        Else
            'get distance from exact aspect for both planets on JD = later_jd
            dist1 = Abs(Y2) - Abs(Y1)

            'get distance from exact aspect for both planets on JD = earlier_jd
            dist2 = Abs(y4) - Abs(y3)
        End If
        
        
        If dist1 - dist2 = 0 Then
            later_jd = (later_jd + earlier_jd) / 2
            d = 0
        Else
            d = ((later_jd - earlier_jd) / (dist1 - dist2)) * dist1
        End If

        If Abs(dist1 - dist2) > 20 And n >= 2 Then
            'keep from looping needlessly AND protect against case where dist1 = -dist2, which gives false aspect
            'example 21 March 2006 - Moon 120 Mars - there is no trine, but an opposition
            later_jd = 0
            
            Exit For
        End If

        If Abs(d) < e Then
            'check to see if this is a parallel or a contra-parallel
            Y1 = Get_1_Planet_decl(later_jd, p1)
            Y2 = Natal_Decl(p2)

            If (aspect_num% = num_aspects% - 1) And ((Y1 >= 0 And Y2 < 0) Or (Y1 < 0 And Y2 >= 0)) Then
                'this doesn't appear to be needed because of the math
                later_jd = 0
            End If

            If (aspect_num% = num_aspects%) And ((Y1 >= 0 And Y2 >= 0) Or (Y1 < 0 And Y2 < 0)) Then
                'this does need to be here
                later_jd = 0
            End If

            Exit For
        End If

        earlier_jd = later_jd

        If Abs(d) >= 1.001 Then
            'out of range - there is no aspect in this time frame (1 day)
            later_jd = 0

            Exit For
        Else
            later_jd = later_jd - d
        End If
    Next n

    If n > m Then
        Result_JD = 0
    Else
        Result_JD = later_jd
    End If
End Sub



