Attribute VB_Name = "Module7"
Option Explicit

Sub Get_LM_file_filename(load_save%)
    Dim t$

    cancel_flag% = 0

    Finding_Lucky_Times!DLog.CancelError = True
    Finding_Lucky_Times!DLog.DefaultExt = "nak"

    If nak_path$ = "" Then
        Finding_Lucky_Times!DLog.InitDir = App.Path
    Else
        Finding_Lucky_Times!DLog.InitDir = nak_path$
    End If

    Finding_Lucky_Times!DLog.filename = nak_filename$

    Finding_Lucky_Times!DLog.Filter = "Lunar mansion (Nakshatra) Files (*.nak) | *.nak"
    Finding_Lucky_Times!DLog.FilterIndex = 1
    Finding_Lucky_Times!DLog.Flags = OFN_OVERWRITEPROMPT Or OFN_PATHMUSTEXIST

    On Error GoTo PVC33f

    If load_save% = 0 Then
        Finding_Lucky_Times!DLog.DialogTitle = "Load .nak transit to lunar mansion file"
        Finding_Lucky_Times!DLog.Action = 1
    Else
        Finding_Lucky_Times!DLog.DialogTitle = "Save .nak transit to lunar mansion file"
        Finding_Lucky_Times!DLog.Action = 2
    End If

    nak_filename$ = Finding_Lucky_Times!DLog.filename
    On Error GoTo 0

    t$ = ParseFilenameOnly(nak_filename$)
    nak_path$ = ParsedPathName$

PVC44f:
    Exit Sub

PVC33f:
    If Err = 32755 Then cancel_flag% = 1             'Cancel was selected

    Resume PVC44f
End Sub

Public Sub Fetch_lunar_mansions_data()
    Dim idx1%, idx2%, nak_num1%, nak_num2%, t$, t1$, t2$, x%, y%
    
    Close #1
    
    If Not FileExists(nak_filename$) Then Exit Sub
    
    Open nak_filename$ For Input As #1

    num_lunar_mansions% = 1
    ReDim mp_data(0 To 9, num_t_deg_to_n_deg% + num_auspicious_points% + 1)
    
    Do While Not EOF(1)
        Line Input #1, t$
        
        y% = InStr(t$, "/")
        
        If y% > 0 Then
            t1$ = Left$(t$, y% - 1)
            t2$ = Mid$(t$, y% + 1)
            
            'now find the index number for the first planet
            nak_num1% = Mid$(t1$, 5, 2)
            nak_num2% = Right$(t1$, 1)
            
            idx1% = (nak_num1% - 1) * 4 + (nak_num2% - 1)       'start deg = idx2% * 3.3333333333333
            
            idx2% = Get_this_planets_index(t2$)
            
            
            If idx1% > 0 And idx2% > 0 Then
                mp_data(0, num_t_deg_to_n_deg% + num_auspicious_points% + num_lunar_mansions%) = t1$           'was just t$
                mp_data(1, num_t_deg_to_n_deg% + num_auspicious_points% + num_lunar_mansions%) = t1$
                mp_data(2, num_t_deg_to_n_deg% + num_auspicious_points% + num_lunar_mansions%) = t2$
                mp_data(3, num_t_deg_to_n_deg% + num_auspicious_points% + num_lunar_mansions%) = idx1% * 3.3333333333333       'the actual degree we want to find
                mp_data(4, num_t_deg_to_n_deg% + num_auspicious_points% + num_lunar_mansions%) = pl_ephem_number(idx2%)
                mp_data(5, num_t_deg_to_n_deg% + num_auspicious_points% + num_lunar_mansions%) = "lm"
                mp_data(6, num_t_deg_to_n_deg% + num_auspicious_points% + num_lunar_mansions%) = pl_type$(idx2%)
                mp_data(7, num_t_deg_to_n_deg% + num_auspicious_points% + num_lunar_mansions%) = idx1%                                    'this could be 0 to 107
                mp_data(8, num_t_deg_to_n_deg% + num_auspicious_points% + num_lunar_mansions%) = idx2%
                mp_data(9, num_t_deg_to_n_deg% + num_auspicious_points% + num_lunar_mansions%) = 4                                           '4 denotes lunar mansion calculation
                
                num_lunar_mansions% = num_lunar_mansions% + 1
                ReDim Preserve mp_data(0 To 9, num_t_deg_to_n_deg% + num_auspicious_points% + num_lunar_mansions%)
                
                'I also have to add this info to the usual arrays for non-midpoint data - so text and grids are correct
                ReDim Preserve planet_names(NumberOfPlanets% + num_t_deg_to_n_deg% + num_auspicious_points% + num_lunar_mansions% - 1)
                ReDim Preserve pl_ephem_number(NumberOfPlanets% + num_t_deg_to_n_deg% + num_auspicious_points% + num_lunar_mansions% - 1)
                ReDim Preserve pl_idx_number(NumberOfPlanets% + num_t_deg_to_n_deg% + num_auspicious_points% + num_lunar_mansions% - 1)
                ReDim Preserve pl_name$(NumberOfPlanets% + num_t_deg_to_n_deg% + num_auspicious_points% + num_lunar_mansions% - 1)
                ReDim Preserve pl_type$(NumberOfPlanets% + num_t_deg_to_n_deg% + num_auspicious_points% + num_lunar_mansions% - 1)
                
                planet_names(NumberOfPlanets% + num_t_deg_to_n_deg% + num_auspicious_points% + num_lunar_mansions% - 1) = mp_data(0, num_t_deg_to_n_deg% + num_auspicious_points% + num_lunar_mansions% - 1)
                pl_name$(NumberOfPlanets% + num_t_deg_to_n_deg% + num_auspicious_points% + num_lunar_mansions% - 1) = UCase$(mp_data(0, num_t_deg_to_n_deg% + num_auspicious_points% + num_lunar_mansions% - 1))
                pl_type$(NumberOfPlanets% + num_t_deg_to_n_deg% + num_auspicious_points% + num_lunar_mansions% - 1) = "lm"
            End If
        End If
    Loop

    num_lunar_mansions% = num_lunar_mansions% - 1
    
    Close #1
End Sub


