Attribute VB_Name = "config"
Option Explicit

'IF YOU CHANGE PLANETS, CHANGE THINGS HERE
'define the "planet" numbers so adding "planets" is easier
Public Const xSE_SUN As Integer = 1
Public Const xSE_MOON As Integer = 2
Public Const xSE_MERCURY As Integer = 3
Public Const xSE_VENUS As Integer = 4
Public Const xSE_MARS As Integer = 5
Public Const xSE_JUPITER As Integer = 6
Public Const xSE_SATURN As Integer = 7
Public Const xSE_URANUS As Integer = 8
Public Const xSE_NEPTUNE As Integer = 9
Public Const xSE_PLUTO As Integer = 10
Public Const xSE_CHIRON As Integer = 11
Public Const xSE_N_NODE As Integer = 12
Public Const xSE_S_NODE As Integer = 13
Public Const xSE_BML As Integer = 14

Public Const xSE_ASC As Integer = 15
Public Const xSE_MC As Integer = 16
Public Const xSE_EQU_ASC As Integer = 17
Public Const xSE_CO_ASC_WK As Integer = 18
Public Const xSE_CO_ASC_MM As Integer = 19
Public Const xSE_POLAR_ASC As Integer = 20
Public Const xSE_VERTEX As Integer = 21
Public Const xSE_POF_d As Integer = 22
Public Const xSE_POF_n As Integer = 23
Public Const xSE_ARIES_PT As Integer = 24

Public Const xSE_01H As Integer = 25
Public Const xSE_02H As Integer = 26
Public Const xSE_03H As Integer = 27
Public Const xSE_04H As Integer = 28
Public Const xSE_05H As Integer = 29
Public Const xSE_06H As Integer = 30
Public Const xSE_07H As Integer = 31
Public Const xSE_08H As Integer = 32
Public Const xSE_09H As Integer = 33
Public Const xSE_10H As Integer = 34
Public Const xSE_11H As Integer = 35
Public Const xSE_12H As Integer = 36

Public Const xSE_AP_1 As Integer = 37
Public Const xSE_AP_2 As Integer = 38
Public Const xSE_AP_3 As Integer = 39
Public Const xSE_AP_4 As Integer = 40
Public Const xSE_AP_5 As Integer = 41
Public Const xSE_AP_6 As Integer = 42
Public Const xSE_AP_7 As Integer = 43

Public Const xSE_CUPIDO As Integer = 44
Public Const xSE_HADES As Integer = 45
Public Const xSE_ZEUS As Integer = 46
Public Const xSE_KRONOS As Integer = 47
Public Const xSE_APOLLON As Integer = 48
Public Const xSE_ADMETOS As Integer = 49
Public Const xSE_VULKANUS As Integer = 50
Public Const xSE_POSEIDON As Integer = 51
Public Const xSE_TRANS_PLUTO As Integer = 52

Public Const xSE_ERIS As Integer = 53
Public Const xSE_QUAOAR As Integer = 54
Public Const xSE_SEDNA As Integer = 55
Public Const xSE_ORCUS As Integer = 56
Public Const xSE_VARUNA As Integer = 57
Public Const xSE_IXION As Integer = 58

Public Const xSE_CERES As Integer = 59
Public Const xSE_PALLAS As Integer = 60
Public Const xSE_JUNO As Integer = 61
Public Const xSE_VESTA As Integer = 62

Public Sub Set_Variables()
    Dim t$, y&

    vrs$ = "1.61"

    num_aspect_elements% = 11        'upper bound of elements in aspects$() array
    
    num_aspects% = 16                     'no verticals at present
    
    num_chkboxes_p1% = 62
    num_chkboxes_p2% = 62
    
    num_chkboxes_aspects% = 17
    

    'associate planet constant name with its index, and its glyph from each of two character sets
    Close #1
    
    If Not FileExists(App.Path & "\planet_constants_and_indexes.txt") Then
        MsgBox "I cannot find your 'planet_constants_and_indexes.txt' file", vbCritical, "Fatal error"
        
        Set Finding_Lucky_Times = Nothing
        
        End
    Else
        num_pl_constants% = 1

        ReDim planet_constant_name$(1)
        ReDim planet_constant_index(1)

        Open App.Path & "\planet_constants_and_indexes.txt" For Input As #1

        Do While Not EOF(1)
            Input #1, t$, y&

            planet_constant_name$(num_pl_constants%) = Trim(t$)
            planet_constant_index(num_pl_constants%) = y&

            num_pl_constants% = num_pl_constants% + 1
            ReDim Preserve planet_constant_name$(num_pl_constants%)
            ReDim Preserve planet_constant_index(num_pl_constants%)
        Loop

        Close #1
    End If

    num_pl_constants% = num_pl_constants% - 1

    'define colors
    clr_black = RGB(0, 0, 0)
    clr_white = RGB(255, 255, 255)

    clr_yellow = RGB(255, 255, 0)
    clr_red = RGB(255, 0, 0)
    clr_green = RGB(45, 192, 0)
    clr_blue = RGB(0, 0, 255)
    clr_light_blue = RGB(192, 192, 255)
    clr_gray = RGB(192, 192, 192)
    clr_another_red = RGB(255, 60, 60)
    clr_another_blue = RGB(120, 120, 255)
    clr_another_gray = RGB(224, 224, 224)
    clr_lime = RGB(156, 206, 4)
End Sub

Public Sub Get_planet_data()
    Dim cnt%, t$, x%

    Close #1

    If Not FileExists(App.Path & "\planets_used.txt") Then
        MsgBox "You are missing the 'planets_used.txt' file.", vbCritical, "Fatal error"
        
        End
    End If

    If Not FileExists(App.Path & "\planet_names.txt") Then
        MsgBox "You are missing the 'planet_names.txt' file.", vbCritical, "Fatal error"
        
        End
    End If

    
    'get number of planets
    NumberOfPlanets% = 0
    Open App.Path & "\planets_used.txt" For Input As #1

    Do While Not EOF(1)
        Line Input #1, t$

        If Trim(t$) <> "" Then
            NumberOfPlanets% = NumberOfPlanets% + 1
        End If
    Loop

    Close #1

    'get planet names
    ReDim planet_names(NumberOfPlanets%)
    
    Open App.Path & "\planet_names.txt" For Input As #1

    cnt% = 1
    
    Do While Not EOF(1)
        Line Input #1, t$

        If Trim(t$) <> "" Then
            planet_names(cnt%) = Trim(t$)
            
            cnt% = cnt% + 1
        End If
    Loop

    Close #1

    ReDim pl_ephem_number(NumberOfPlanets%)
    ReDim pl_idx_number(NumberOfPlanets%)
    ReDim pl_name$(NumberOfPlanets%)
    ReDim pl_type$(NumberOfPlanets%)

    'assign planet numbers, planet names and types, and planet glyphs for planets
    cnt% = 1

    num_geo_planets% = 0
    num_house_cusps% = 0
    num_points% = 0
    num_arabic_parts% = 0
    num_tnps% = 0
    num_dwarfs% = 0
    num_asteroids% = 0

    Open App.Path & "\planets_used.txt" For Input As #1

    Do While Not EOF(1)
        Line Input #1, t$

        t$ = Trim(t$)

        If t$ <> "" Then
            'match planet code with proper planet number
            For x% = 1 To num_pl_constants%
                If planet_constant_name$(x%) = Mid$(t$, 3) Then
                    pl_ephem_number(cnt%) = planet_constant_index(x%)
                    Exit For
                End If
            Next x%

            If x% <= num_pl_constants% Then
                pl_type$(cnt%) = LCase$(Left$(t$, 1))

                If pl_type$(cnt%) = "g" Then num_geo_planets% = num_geo_planets% + 1
                If pl_type$(cnt%) = "c" Then num_house_cusps% = num_house_cusps% + 1
                If pl_type$(cnt%) = "p" Then num_points% = num_points% + 1
                If pl_type$(cnt%) = "l" Then num_arabic_parts% = num_arabic_parts% + 1
                If pl_type$(cnt%) = "t" Then num_tnps% = num_tnps% + 1
                If pl_type$(cnt%) = "d" Then num_dwarfs% = num_dwarfs% + 1
                If pl_type$(cnt%) = "a" Then num_asteroids% = num_asteroids% + 1

                pl_name$(cnt%) = Mid$(t$, 6)
                pl_idx_number(cnt%) = x%

                cnt% = cnt% + 1
            End If
        End If
not_okay:
    Loop

    Close #1
End Sub

Public Sub Get_aspect_data()
'    num_aspects% = 16                     'no verticals at present
'    num_chkboxes_aspects% = 17
    Dim cnt%, t$

    Close #1
    
    If Not FileExists(App.Path & "\aspect_definitions.txt") Then
        MsgBox "I cannot find your 'aspect_definitions.txt' file", vbCritical, "Fatal error"
        
        Set Finding_Lucky_Times = Nothing
        
        End
    Else
        cnt% = 0
        
        Open App.Path & "\aspect_definitions.txt" For Input As #1

        Do While Not EOF(1)
            Input #1, t$

            Finding_Lucky_Times!chkAspects(cnt%).Caption = Trim(t$)
            
            cnt% = cnt% + 1
        Loop

        Close #1
    End If
End Sub
